//+------------------------------------------------------------------+
//|                                                 FindLotForSL.mq5 |
//|                                  Copyright 2023, MetaQuotes Ltd. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2023, MetaQuotes Ltd."
#property link      "https://www.mql5.com"
#property version   "1.00"
#include <PlugAndPlay\trading\symbolTradingCosts.mqh>
enum direction{
buy=0,//buy
sell=1//sell
};
input direction Direction=buy;//Direction
input double SLPrice=1.0;//Desired SL Price
input double Risk=5.0;//Risk % (0-100 scale)

int OnInit()
  {
  EventSetMillisecondTimer(44);
  return(INIT_SUCCEEDED);
  }

void OnTimer(){
  EventKillTimer();
  while(!SymbolIsSynchronized(_Symbol)){
       Comment("Please wait...");
       Sleep(300);
       }
    ENUM_ORDER_TYPE type=ORDER_TYPE_BUY;
    if(Direction==sell){type=ORDER_TYPE_SELL;}
    double tick_value_for_one_lot=0.0;
    if(get_tick_value_for_one_lot(_Symbol,type,tick_value_for_one_lot)){
      //open price is the ask 
        ResetLastError();
        double op=0.0;
        if(Direction==buy){op=(double)SymbolInfoDouble(_Symbol,SYMBOL_ASK);}
        else{op=(double)SymbolInfoDouble(_Symbol,SYMBOL_BID);}
        if(GetLastError()==0){
        // 
          if((Direction==buy&&SLPrice<op)||(Direction==sell&&SLPrice>op)){
          //distance in "ticks"
          double distance=0.0;
          if(Direction==buy){distance=(op-SLPrice)/_Point;}
          else{distance=(SLPrice-op)/_Point;}
          //so for 1 lot the cost of that distance will be : 
            double cost_for_one_lot=distance*tick_value_for_one_lot;
            //and you have a specific value you want to rix in mind so if we divide that value by the cost for 1 lot
            //we will get ... the lot you must use
              ResetLastError();
              double balance=(double)AccountInfoDouble(ACCOUNT_BALANCE);
              if(GetLastError()==0){
              double amount_to_risk=(balance/100.0)*Risk;
              double lot_to_use=amount_to_risk/cost_for_one_lot;
              double min_lot=0.0,max_lot=0.0,step_lot=0.0,lot_limit=0.0;
              if(get_lot_limits(_Symbol,min_lot,max_lot,lot_limit,step_lot)){
                int lot_digits=get_digits_by_min_value(min_lot);
                lot_to_use=NormalizeDouble(lot_to_use,lot_digits);
                if(lot_to_use>max_lot){lot_to_use=max_lot;}
                if(lot_to_use<min_lot){lot_to_use=min_lot;}
                Alert("Lot to use ("+DoubleToString(lot_to_use,lot_digits)+")");
                }else{
                Alert("Cannot get lots");
                }
              }else{
              Alert("Cannot get balance");
              }
          }else{
          Alert("The SL is invalid");
          }
        }
      }else{
      Alert("Cannot get tick value for one lot for a buy");
      }
  ExpertRemove();
  }

void OnDeinit(const int reason)
  {  
  }

void OnTick()
  {   
  }
